(load "oop.lsp")

(defclass cpoint)

(defmethod write-x ((obj cpoint) xx) (setf (gethash 'x obj) xx))

(defmethod write-y ((obj cpoint) yy) (setf (gethash 'y obj) yy))

(defmethod read-x ((obj cpoint)) (gethash 'x obj))

(defmethod read-y ((obj cpoint)) (gethash 'y obj))

(defmethod move ((obj cpoint) dx dy)
    (tell obj 'write-x (+ dx (tell obj 'read-x)))
    (tell obj 'write-y (+ dy (tell obj 'read-y))) )

(setq p (make-instanse 'cpoint))

(tell p 'write-x 10)

(tell p 'write-y 20)

(print (tell p 'read-x))

(print (tell p 'read-y))

(tell p 'move -30 5)

(print (tell p 'read-x))

(print (tell p 'read-y))
